import { computed as m, onMounted as je, ref as b, watch as Xe, createElementBlock as f, openBlock as c, unref as i, normalizeStyle as S, normalizeClass as Fe, createBlock as G, createCommentVNode as N, createVNode as ne, createSlots as qe, withCtx as k, renderSlot as y, normalizeProps as A, guardReactiveProps as H, createElementVNode as J, Fragment as R, renderList as U, toDisplayString as re, createTextVNode as Je, nextTick as Ze } from "vue";
import { u as Ke, o as Qe, e as et, c as ue, t as tt, p as ie, a as ot, b as lt, v as g, f as V, X as at, G as Pe, J as st, i as ce, q as nt, r as rt, x as ut } from "./index-Co_0CzhC.js";
import { _ as it } from "./Title-BDdzEGgo.js";
import { u as ct, U as dt } from "./usePrinter-BV6TePSm.js";
import { D as vt } from "./DataTable-BhwIv7c6.js";
import ft from "./vue-ui-accordion-DMCnTtx0.js";
import ht from "./vue-ui-skeleton-Dzehgcp3.js";
import { u as Se } from "./useNestedProp-DqI_VUcm.js";
import { _ as pt } from "./PackageVersion-DmKsiZge.js";
import { _ as gt } from "./PenAndPaper-Dgf1a1MW.js";
import { u as mt } from "./useUserOptionState-BIvW1Kz7.js";
import { u as yt } from "./useChartAccessibility-BWojgys7.js";
import { _ as bt } from "./Tooltip-Cdkz2ese.js";
import { _ as kt } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const wt = ["id"], Ct = {
  key: 1,
  ref: "noTitle",
  class: "vue-data-ui-no-title-space",
  style: "height:36px; width: 100%;background:transparent"
}, $t = {
  key: 2,
  style: "width:100%;background:transparent;padding-bottom:24px"
}, Tt = ["xmlns", "viewBox"], xt = ["width", "height"], _t = ["id"], Ot = ["stop-color"], Nt = ["stop-color"], Ft = ["d", "fill", "stroke", "stroke-width"], Pt = ["x", "y", "height", "width", "fill", "stroke", "stroke-width", "onMouseenter"], St = ["x", "y", "font-size", "fill"], It = ["x", "y", "font-size", "fill"], Et = {
  key: 4,
  class: "vue-data-ui-watermark"
}, At = {
  key: 6,
  ref: "source",
  dir: "auto"
}, Ht = ["innerHTML"], Lt = {
  __name: "vue-ui-flow",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  setup(Ie, { expose: Ee }) {
    const { vue_ui_flow: Ae } = Ke(), $ = Ie, Z = m(() => !!$.dataset && $.dataset.length);
    je(() => {
      de();
    });
    function de() {
      Qe($.dataset) && et({
        componentName: "VueUiFlow",
        type: "dataset"
      });
    }
    const K = b(ue()), Q = b(null), ve = b(0), fe = b(0), ee = b(!1), te = b(""), I = b(!1);
    function He(t) {
      I.value = t, ve.value += 1;
    }
    const e = m({
      get: () => me(),
      set: (t) => t
    }), { userOptionsVisible: oe, setUserOptionsVisibility: he, keepUserOptionState: pe } = mt({ config: e.value }), { svgRef: ge } = yt({ config: e.value.style.chart.title });
    function me() {
      const t = Se({
        userConfig: $.config,
        defaultConfig: Ae
      });
      return t.theme ? {
        ...Se({
          userConfig: ot.vue_ui_flow[t.theme] || $.config,
          defaultConfig: t
        }),
        customPalette: tt[t.theme] || ie
      } : t;
    }
    Xe(() => $.config, (t) => {
      e.value = me(), oe.value = !e.value.userOptions.showOnChartHover, de(), fe.value += 1, x.value.showTable = e.value.table.show;
    }, { deep: !0 });
    const { isPrinting: ye, isImaging: be, generatePdf: ke, generateImage: we } = ct({
      elementId: `flow_${K.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-flow",
      options: e.value.userOptions.print
    }), Le = m(() => e.value.userOptions.show && !e.value.style.chart.title.text), le = m(() => lt(e.value.customPalette)), Ce = m(() => e.value.style.chart.nodes.gap), E = m(() => e.value.style.chart.nodes.width), x = b({
      showTable: e.value.table.show,
      showTooltip: e.value.style.chart.tooltip.show
    }), $e = m(() => e.value.style.chart.links.width), B = m(() => !$.dataset || !$.dataset.length ? [] : $.dataset.map((t) => [
      t[0],
      t[1],
      g(t[2])
    ])), Te = m(() => {
      const t = {};
      function l(a) {
        t[a] || (t[a] = { inflow: 0, outflow: 0 });
      }
      B.value.forEach(([a, s, v]) => {
        l(a), l(s), t[a].outflow += v, t[s].inflow += v;
      });
      let o = 0;
      for (const a in t) {
        const s = Math.max(t[a].inflow, t[a].outflow);
        o = Math.max(o, s);
      }
      return o;
    });
    function Me(t) {
      return t / Te.value * 100 + e.value.style.chart.nodes.minHeight;
    }
    function ze(t) {
      const l = e.value.style.chart.nodes.minHeight;
      return (t - l) / 100 * Te.value;
    }
    function Ye(t) {
      const l = {}, o = {};
      function a(n, u) {
        l[n] || (l[n] = { height: 0, level: null, inflow: 0, outflow: 0, uid: ue() }), l[n].level === null && (l[n].level = u), o[u] || (o[u] = []), o[u].includes(n) || o[u].push(n);
      }
      t.forEach(([n, u, h], P) => {
        const T = l[n] ? l[n].level : 0, _ = T + 1;
        a(n, T), a(u, _), l[n].children || (l[n].children = []), l[n].children.push({ target: u, value: h }), l[n].outflow += h, l[u].inflow += h;
      }), Object.keys(l).forEach((n, u) => {
        l[n].color = le.value[u] || le.value[u % le.value.length] || ie[u] || ie[u % d.length];
      });
      for (const n in l)
        l[n].height = Me(Math.max(l[n].inflow, l[n].outflow)), l[n].name = n;
      const s = {};
      for (const n in o) {
        let u = 0;
        o[n].forEach((h, P) => {
          const T = l[h].height;
          s[h] = {
            x: parseInt(n, 10) * $e.value + e.value.style.chart.padding.left,
            y: u,
            absoluteY: u,
            height: T,
            i: P,
            color: l[h].color,
            value: ze(T)
          }, u += T + Ce.value;
        });
      }
      const v = [];
      for (const n in l) {
        let u = s[n].absoluteY + e.value.style.chart.padding.top;
        l[n].children && l[n].children.forEach(({ target: h, value: P }, T) => {
          const _ = s[h].y + e.value.style.chart.padding.top, M = s[n], z = s[h], w = g(u), O = g(u + P / l[n].outflow * M.height), Y = g(_), r = g(_ + P / l[h].inflow * z.height), p = {
            id: ue(),
            source: n,
            target: h,
            path: `M ${g(M.x) + g(E.value)} ${w} L ${g(M.x) + g(E.value)} ${O} L ${g(z.x)} ${r} L ${g(z.x)} ${Y} Z`,
            value: P,
            sourceColor: l[n].color,
            targetColor: l[h].color
          };
          v.push(p), u += O - w, s[h].y += r - Y;
        });
      }
      return { nodeCoordinates: s, links: v };
    }
    const C = m(() => {
      const t = Ye($.dataset);
      return {
        nodes: Object.keys(t.nodeCoordinates).map((l, o) => ({
          ...t.nodeCoordinates[l],
          name: l
        })),
        links: t.links
      };
    }), De = m(() => Ge(C.value.nodes));
    function Ge(t) {
      const l = {};
      for (const a in t) {
        const { x: s, height: v } = t[a];
        l[s] || (l[s] = 0), l[s] += v + Ce.value;
      }
      return Math.max(...Object.values(l));
    }
    const L = m(() => {
      const { top: t, right: l, left: o, bottom: a } = e.value.style.chart.padding, s = B.value.length * $e.value;
      return {
        height: De.value + t + a,
        width: l + Math.max(...C.value.nodes.map((v) => v.x)) + E.value,
        left: o,
        top: t,
        right: s - l,
        p_top: t,
        p_bottom: a
      };
    });
    function Re(t) {
      const l = {}, o = {}, a = /* @__PURE__ */ new Set();
      return B.value.forEach(([s, v, n]) => {
        l[s] || (l[s] = []), o[v] || (o[v] = []), l[s].push(v), o[v].push(s);
      }), l[t] && l[t].forEach((s) => a.add(s)), o[t] && o[t].forEach((s) => a.add(s)), Array.from(a).concat(t);
    }
    const F = b(null), W = b(null), ae = b(null), j = b(!1);
    function Ue(t) {
      F.value = Re(t.name), W.value = t.name;
      const l = t.name, o = B.value;
      let a = 0, s = 0, v = [], n = [];
      const u = new Set(o.map(([r]) => r)), h = new Set(o.map(([, r]) => r)), P = Array.from(u).filter((r) => !h.has(r)), T = o.filter(([r]) => P.includes(r)).reduce((r, [p, D, We]) => r + We, 0), _ = {};
      C.value.nodes.forEach((r) => {
        _[r.name] = r.color;
      }), o.forEach(([r, p, D]) => {
        p === l && (a += D, v.push({ source: r, value: D, color: _[r] })), r === l && (s += D, n.push({ target: p, value: D, color: _[p] }));
      });
      const M = Math.max(a, s), z = T > 0 ? M / T * 100 : 0, w = {
        name: l,
        inflow: a,
        outflow: s,
        from: v,
        to: n,
        percentOfTotal: z,
        color: _[l] || "#000000"
      };
      ae.value = { datapoint: w }, ee.value = !0;
      let O = "";
      const Y = e.value.style.chart.tooltip.customFormat;
      if (j.value = !1, ut(Y))
        try {
          const r = Y({
            datapoint: w,
            series: C.value,
            config: e.value
          });
          typeof r == "string" && (te.value = r, j.value = !0);
        } catch {
          console.warn("Custom format cannot be applied.");
        }
      if (!j.value) {
        const r = e.value.style.chart.tooltip.showPercentage ? `<div>${V({
          p: e.value.style.chart.tooltip.translations.percentOfTotal,
          v: w.percentOfTotal,
          s: "%",
          r: e.value.style.chart.tooltip.roundingPercentage
        })}</div>` : "";
        O += `<div style="width:100%;text-align:center;border-bottom:1px solid ${e.value.style.chart.tooltip.borderColor};padding-bottom:6px;margin-bottom:3px;"><span style="margin-right:4px; color:${w.color}">⏹</span>${w.name}${r}</div>`, w.from.length && (O += `<div>${e.value.style.chart.tooltip.translations.from}</div>`, w.from.forEach((p) => {
          O += `<div><span style="color:${p.color}">⏹←</span> ${p.source}: ${ce(
            e.value.style.chart.nodes.labels.formatter,
            p.value,
            V({
              p: e.value.style.chart.nodes.labels.prefix,
              v: p.value,
              s: e.value.style.chart.nodes.labels.suffix,
              r: e.value.style.chart.nodes.labels.rounding
            })
          )}</div>`;
        })), w.to.length && (O += `<div style="margin-top:6px;">${e.value.style.chart.tooltip.translations.to}</div>`, w.to.forEach((p) => {
          O += `<div><span style="color:${p.color}">⏹→</span> ${p.target}: ${ce(
            e.value.style.chart.nodes.labels.formatter,
            p.value,
            V({
              p: e.value.style.chart.nodes.labels.prefix,
              v: p.value,
              s: e.value.style.chart.nodes.labels.suffix,
              r: e.value.style.chart.nodes.labels.rounding
            })
          )}</div>`;
        })), te.value = O;
      }
    }
    function Ve() {
      F.value = null, W.value = null, ee.value = !1;
    }
    const xe = m(() => C.value.links.map(({ source: t, target: l, sourceColor: o, targetColor: a, value: s }) => ({
      source: t,
      target: l,
      sourceColor: o,
      targetColor: a,
      value: s
    })));
    function _e() {
      Ze(() => {
        const t = xe.value.map((a, s) => [
          [a.source],
          [a.target],
          [a.value]
        ]), l = [
          [e.value.style.chart.title.text],
          [e.value.style.chart.title.subtitle.text],
          [
            [e.value.table.columnNames.source],
            [e.value.table.columnNames.target],
            [e.value.table.columnNames.value]
          ]
        ].concat(t), o = nt(l);
        rt({
          csvContent: o,
          title: e.value.style.chart.title.text || "vue-ui-flow"
        });
      });
    }
    const X = m(() => {
      const t = [
        e.value.table.columnNames.source,
        e.value.table.columnNames.target,
        e.value.table.columnNames.value
      ], l = xe.value.map((s, v) => [
        {
          color: s.sourceColor,
          name: s.source
        },
        {
          color: s.targetColor,
          name: s.target
        },
        V({
          p: e.value.style.chart.nodes.labels.prefix,
          v: s.value,
          s: e.value.style.chart.nodes.labels.suffix,
          r: e.value.style.chart.nodes.labels.rounding
        })
      ]), o = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return {
        colNames: [
          e.value.table.columnNames.source,
          e.value.table.columnNames.target,
          e.value.table.columnNames.value
        ],
        head: t,
        body: l,
        config: o
      };
    });
    function Be() {
      return C.value;
    }
    function Oe() {
      x.value.showTable = !x.value.showTable;
    }
    const q = b(!1);
    function se() {
      q.value = !q.value;
    }
    function Ne() {
      x.value.showTooltip = !x.value.showTooltip;
    }
    return Ee({
      getData: Be,
      generateCsv: _e,
      generateImage: we,
      generatePdf: ke,
      toggleTable: Oe,
      toggleAnnotator: se,
      toggleTooltip: Ne
    }), (t, l) => (c(), f("div", {
      ref_key: "flowChart",
      ref: Q,
      class: Fe(`vue-ui-flow ${I.value ? "vue-data-ui-wrapper-fullscreen" : ""}`),
      style: S(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;background:${e.value.style.chart.backgroundColor}`),
      id: `flow_${K.value}`,
      onMouseenter: l[2] || (l[2] = () => i(he)(!0)),
      onMouseleave: l[3] || (l[3] = () => i(he)(!1))
    }, [
      e.value.userOptions.buttons.annotator ? (c(), G(gt, {
        key: 0,
        svgRef: i(ge),
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: q.value,
        onClose: se
      }, null, 8, ["svgRef", "backgroundColor", "color", "active"])) : N("", !0),
      Le.value ? (c(), f("div", Ct, null, 512)) : N("", !0),
      e.value.style.chart.title.text ? (c(), f("div", $t, [
        (c(), G(it, {
          key: `title_${fe.value}`,
          config: {
            title: {
              cy: "flow-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "flow-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ])) : N("", !0),
      e.value.userOptions.show && Z.value && (i(pe) || i(oe)) ? (c(), G(dt, {
        ref: "details",
        key: `user_option_${ve.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: i(ye),
        isImaging: i(be),
        uid: K.value,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasXls: e.value.userOptions.buttons.csv,
        hasImg: e.value.userOptions.buttons.img,
        hasTable: e.value.userOptions.buttons.table,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: I.value,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: Q.value,
        position: e.value.userOptions.position,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: q.value,
        hasTooltip: e.value.style.chart.tooltip.show && e.value.userOptions.buttons.tooltip,
        isTooltip: x.value.showTooltip,
        onToggleTooltip: Ne,
        onToggleFullscreen: He,
        onGeneratePdf: i(ke),
        onGenerateCsv: _e,
        onGenerateImage: i(we),
        onToggleTable: Oe,
        onToggleAnnotator: se,
        style: S({
          visibility: i(pe) ? i(oe) ? "visible" : "hidden" : "visible"
        })
      }, qe({ _: 2 }, [
        t.$slots.menuIcon ? {
          name: "menuIcon",
          fn: k(({ isOpen: o, color: a }) => [
            y(t.$slots, "menuIcon", A(H({ isOpen: o, color: a })), void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: k(() => [
            y(t.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: k(() => [
            y(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        t.$slots.optionCsv ? {
          name: "optionCsv",
          fn: k(() => [
            y(t.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: k(() => [
            y(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        t.$slots.optionTable ? {
          name: "optionTable",
          fn: k(() => [
            y(t.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "5"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: k(({ toggleFullscreen: o, isFullscreen: a }) => [
            y(t.$slots, "optionFullscreen", A(H({ toggleFullscreen: o, isFullscreen: a })), void 0, !0)
          ]),
          key: "6"
        } : void 0,
        t.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: k(({ toggleAnnotator: o, isAnnotator: a }) => [
            y(t.$slots, "optionAnnotator", A(H({ toggleAnnotator: o, isAnnotator: a })), void 0, !0)
          ]),
          key: "7"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasPdf", "hasXls", "hasImg", "hasTable", "hasFullscreen", "isFullscreen", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "hasTooltip", "isTooltip", "onGeneratePdf", "onGenerateImage", "style"])) : N("", !0),
      (c(), f("svg", {
        ref_key: "svgRef",
        ref: ge,
        xmlns: i(at),
        viewBox: `0 0 ${L.value.width} ${L.value.height}`,
        class: Fe({ "vue-data-ui-fullscreen--on": I.value, "vue-data-ui-fulscreen--off": !I.value }),
        style: S(`max-width:100%; overflow: visible; background:transparent;color:${e.value.style.chart.color}`)
      }, [
        ne(pt),
        t.$slots["chart-background"] ? (c(), f("foreignObject", {
          key: 0,
          x: 0,
          y: 0,
          width: L.value.width,
          height: L.value.height,
          style: {
            pointerEvents: "none"
          }
        }, [
          y(t.$slots, "chart-background", {}, void 0, !0)
        ], 8, xt)) : N("", !0),
        J("defs", null, [
          (c(!0), f(R, null, U(C.value.links, (o, a) => (c(), f("linearGradient", {
            id: o.id,
            x1: "0%",
            y1: "0%",
            x2: "100%",
            y2: "0%"
          }, [
            J("stop", {
              offset: "0%",
              "stop-color": o.sourceColor
            }, null, 8, Ot),
            J("stop", {
              offset: "100%",
              "stop-color": o.targetColor
            }, null, 8, Nt)
          ], 8, _t))), 256))
        ]),
        (c(!0), f(R, null, U(C.value.links, (o) => (c(), f("path", {
          class: "vue-ui-flow-link",
          d: o.path,
          fill: `url(#${o.id})`,
          stroke: e.value.style.chart.links.stroke,
          "stroke-width": e.value.style.chart.links.strokeWidth,
          style: S(`opacity:${W.value ? [o.target, o.source].includes(W.value) ? 1 : 0.3 : e.value.style.chart.links.opacity}`)
        }, null, 12, Ft))), 256)),
        (c(!0), f(R, null, U(C.value.nodes, (o, a) => (c(), f("rect", {
          class: "vue-ui-flow-node",
          x: o.x,
          y: i(g)(o.absoluteY) + e.value.style.chart.padding.top,
          height: i(g)(o.height),
          width: E.value,
          fill: o.color,
          stroke: e.value.style.chart.nodes.stroke,
          "stroke-width": e.value.style.chart.nodes.strokeWidth,
          onMouseenter: (s) => Ue(o),
          onMouseleave: l[0] || (l[0] = (s) => Ve()),
          style: S(`opacity:${F.value ? F.value.includes(o.name) ? 1 : 0.2 : 1}`)
        }, null, 44, Pt))), 256)),
        (c(!0), f(R, null, U(C.value.nodes, (o, a) => (c(), f("text", {
          x: o.x + E.value / 2,
          y: i(g)(o.absoluteY + o.height / 2 - e.value.style.chart.nodes.labels.fontSize / 4) + e.value.style.chart.padding.top,
          "font-size": e.value.style.chart.nodes.labels.fontSize,
          fill: i(Pe)(o.color),
          "text-anchor": "middle",
          style: S(`pointer-events: none; opacity:${F.value ? F.value.includes(o.name) ? 1 : 0 : 1}`)
        }, re(e.value.style.chart.nodes.labels.abbreviation.use ? i(st)({
          source: o.name,
          length: e.value.style.chart.nodes.labels.abbreviation.length
        }) : o.name), 13, St))), 256)),
        (c(!0), f(R, null, U(C.value.nodes, (o, a) => (c(), f("text", {
          x: o.x + E.value / 2,
          y: i(g)(o.absoluteY + o.height / 2 + e.value.style.chart.nodes.labels.fontSize) + e.value.style.chart.padding.top,
          "font-size": e.value.style.chart.nodes.labels.fontSize,
          fill: i(Pe)(o.color),
          "text-anchor": "middle",
          style: S(`pointer-events: none; opacity:${F.value ? F.value.includes(o.name) ? 1 : 0 : 1}`)
        }, re(i(ce)(
          e.value.style.chart.nodes.labels.formatter,
          o.value,
          i(V)({
            p: e.value.style.chart.nodes.labels.prefix,
            v: o.value,
            s: e.value.style.chart.nodes.labels.suffix,
            r: e.value.style.chart.nodes.labels.rounding
          }),
          { datapoint: o, seriesIndex: a }
        )), 13, It))), 256)),
        y(t.$slots, "svg", { svg: L.value }, void 0, !0)
      ], 14, Tt)),
      t.$slots.watermark ? (c(), f("div", Et, [
        y(t.$slots, "watermark", A(H({ isPrinting: i(ye) || i(be) })), void 0, !0)
      ])) : N("", !0),
      Z.value ? N("", !0) : (c(), G(ht, {
        key: 5,
        config: {
          type: "flow",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor
          }
        }
      }, null, 8, ["config"])),
      t.$slots.source ? (c(), f("div", At, [
        y(t.$slots, "source", {}, void 0, !0)
      ], 512)) : N("", !0),
      ne(bt, {
        show: x.value.showTooltip && ee.value,
        backgroundColor: e.value.style.chart.tooltip.backgroundColor,
        color: e.value.style.chart.tooltip.color,
        fontSize: e.value.style.chart.tooltip.fontSize,
        borderRadius: e.value.style.chart.tooltip.borderRadius,
        borderColor: e.value.style.chart.tooltip.borderColor,
        borderWidth: e.value.style.chart.tooltip.borderWidth,
        backgroundOpacity: e.value.style.chart.tooltip.backgroundOpacity,
        position: e.value.style.chart.tooltip.position,
        offsetY: e.value.style.chart.tooltip.offsetY,
        parent: Q.value,
        content: te.value,
        isCustom: j.value,
        isFullscreen: I.value
      }, {
        "tooltip-before": k(() => [
          y(t.$slots, "tooltip-before", A(H({ ...ae.value })), void 0, !0)
        ]),
        "tooltip-after": k(() => [
          y(t.$slots, "tooltip-after", A(H({ ...ae.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "fontSize", "borderRadius", "borderColor", "borderWidth", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom", "isFullscreen"]),
      Z.value ? (c(), G(ft, {
        key: 7,
        hideDetails: "",
        config: {
          open: x.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: k(() => [
          ne(vt, {
            colNames: X.value.colNames,
            head: X.value.head,
            body: X.value.body,
            config: X.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: l[1] || (l[1] = (o) => x.value.showTable = !1)
          }, {
            th: k(({ th: o }) => [
              J("div", {
                innerHTML: o,
                style: { display: "flex", "align-items": "center" }
              }, null, 8, Ht)
            ]),
            td: k(({ td: o }) => [
              Je(re(o.name || o), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"])
        ]),
        _: 1
      }, 8, ["config"])) : N("", !0)
    ], 46, wt));
  }
}, Zt = /* @__PURE__ */ kt(Lt, [["__scopeId", "data-v-17e83e4a"]]);
export {
  Zt as default
};
